#line 1 ".\Src\MAIN.c"
#line 1 "C:\Sonix\SN8_C_~1.264\C\include\SonixDef.h"



unsigned long GetRollingCode(unsigned int offset);








struct _intrinsicbitfield
{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};













#line 1 ".\Src\MAIN.c"
#line 1 ".\Include\FC2704.h"

#line 5 ".\Include\FC2704.h"








struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;
















sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;
sfr	RBANK = 0x87;


 sfr    TM0M    =0X90;
 sfr    TM0CL   =0X91;
 sfr    TM0CH   =0X92;
 sfr    TM0D0L  =0X93;
 sfr    TM0D0H  =0X94;
 sfr    TM0D1L  =0X95;
 sfr    TM0D1H  =0X96;
 sfr    PWM0E   =0X97;

 sfr	SPIC0	=0X98;
 sfr	SPIC1	=0X99;
 sfr	SPIBUF	=0X9A;


 sfr    TM1M    =0XA0;
 sfr    TM1C    =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1   =0XA3;
 sfr    TM1D2   =0XA4;
 sfr    TM1D3   =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;


 sfr    TM2M    =0XB0;
 sfr    TM2C    =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1   =0XB3;
 sfr    TM2D2   =0XB4;
 sfr    TM2D3   =0XB5;
 sfr    PWM2E   =0XB6;





 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;




 sfr    ADM    =0XB9;
 sfr    ADB    =0XBa;
 sfr    ADR    =0XBb;
 sfr    ADT    =0XBc;
 sfr    VREFH  =0XBd;
 sfr    ADPCON =0Xbe;
 sfr	PEDGE  =0XBF;


 sfr    P1W    =0XC0;
 sfr	P1M    =0xC1;
 sfr	P2M    =0XC2;
 sfr	P3M    =0XC3;
 sfr    INTRQ1 =0XC6;
 sfr    INTEN1 =0XC7;

 sfr    INTRQ  =0XC8;
 sfr    INTEN  =0XC9;
 sfr	OSCM   =0xCA;
 sfr	RCADJ  =0XCB;
 sfr	WDTR   =0XCC;
 sfr    OPTION =0XCD;
 sfr	PCL    =0XCE;
 sfr	PCH    =0XCF;


 sfr	P1     =0XD1;
 sfr	P2     =0XD2;
 sfr	P3     =0XD3;
 sfr	T0M    =0XD8;
 sfr	T0C    =0XD9;
 sfr    OPA1CON=0XDA;
 sfr    OPA2CON=0XDB;
 sfr    P1OD   =0XDC;
 sfr    P2W    =0Xdd;
 sfr    P3W    =0XDE;
 sfr    STKP   =0XDF;


 sfr	P1UR=0XE1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;


 sfr	P1PD=0XEC;
 sfr	P2PD=0XED;
 sfr	P3PD=0XEE;


sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAB:2;
sbit	E2P_PG		=0xAB:1;
sbit	E2P_RD		=0xAB:0;

sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		=0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;


sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		=0xA8:4;
sbit	HBB		=0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		=0xA8:7;



sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;




sbit	CHS0		=0xB9:0;
sbit	CHS1		=0xB9:1;
sbit	CHS2		=0xB9:2;
sbit	CHS3		=0xB9:3;
sbit	GCHS		=0xB9:4;
sbit	EOC		=0xB9:5;
sbit	FADS		=0xB9:6;
sbit	ADENB		=0xB9:7;



sbit	ADCKS0		=0xBB:4;
sbit	ADCKS1		=0xBB:6;



sbit	ADT_0		=0xBc:0;
sbit	ADT_1		=0xBC:1;
sbit	ADT_2		=0xBC:2;
sbit	ADT_3		=0xBC:3;
sbit	ADT_4		=0xBC:4;

sbit	adts_0		=0xBC:6;
sbit	adts_1		=0xBC:7;


sbit	VHS0		=0xBD:0;
sbit	VHS1		=0xBD:1;

sbit	EVHENB		=0xBD:7;



sbit	PWM0OE		=0x90:0;
sbit	ALOAD0		=0x90:1;
sbit	T0CKS0		=0x90:2;
sbit	T0CKS1		=0x90:3;
sbit	T0PS0		=0x90:4;
sbit	T0PS1		=0x90:5;
sbit	T0PS2		=0x90:6;
sbit	T0TR		=0x90:7;

sbit	PWM1OE		=0xA0:0;
sbit	ALOAD1		=0xA0:1;
sbit	T1CKS0		=0xA0:2;
sbit	T1CKS1		=0xA0:3;
sbit	T1PS0		=0xA0:4;
sbit	T1PS1		=0xA0:5;
sbit	T1PS2		=0xA0:6;
sbit	T1TR		=0xA0:7;

sbit	PWM2OE		=0xB0:0;
sbit	ALOAD2		=0xB0:1;
sbit	T2CKS0		=0xB0:2;
sbit	T2CKS1		=0xB0:3;
sbit	T2PS0		=0xB0:4;
sbit	T2PS1		=0xB0:5;
sbit	T2PS2		=0xB0:6;
sbit	T2TR		=0xB0:7;


sbit	PWM01E		=0x97:0;
sbit	PWM00HL		=0x97:1;
sbit	PWM01HL		=0x97:2;
sbit	PWM0M		=0x97:3;
sbit	PWM00OE		=0x97:4;
sbit	PWM01OE		=0x97:5;
sbit	TC0WAKE		=0x97:6;
sbit	PWM0OD		=0x97:7;

sbit	PWM11E		=0xA6:0;
sbit	PWM10HL		=0xA6:1;
sbit	PWM11HL		=0xA6:2;
sbit	PWM1M		=0xA6:3;
sbit	PWM10OE		=0xA6:4;
sbit	PWM11OE		=0xA6:5;
sbit	TC1WAKE		=0xA6:6;
sbit	PWM1OD		=0xA6:7;

sbit	PWM21E		=0xB6:0;
sbit	PWM20HL		=0xB6:1;
sbit	PWM21HL		=0xB6:2;
sbit	PWM2M		=0xB6:3;
sbit	PWM20OE		=0xB6:4;
sbit	PWM21OE		=0xB6:5;
sbit	TC2WAKE		=0xB6:6;
sbit	PWM2OD		=0xB6:7;



sbit	INT0IE		=0xc9:0;
sbit	INT1IE		=0xc9:1;
sbit	TM0IE		=0xc9:2;
sbit	TM1IE		=0xc9:3;
sbit	TM2IE		=0xc9:4;
sbit	FRPIE		=0xc9:5;
sbit	I2CIE		=0xc9:6;
sbit	ADCIE		=0xc9:7;

sbit	E2PIE		=0xc7:0;
sbit	TKTMRIE		=0xc7:1;
sbit	SPIIE		=0xc7:2;
sbit	T0IE	    =0xC7:3;
sbit	OPAIE    	=0xC7:4;

sbit	INT0IF		=0xc8:0;
sbit	INT1IF		=0xc8:1;
sbit	TM0IF		=0xc8:2;
sbit	TM1IF		=0xc8:3;
sbit	TM2IF		=0xc8:4;
sbit	FRPIF		=0xc8:5;
sbit	I2CIF		=0xc8:6;
sbit	ADCIF		=0xc8:7;

sbit	E2PIF		=0xc6:0;
sbit	TKTMRIF		=0xc6:1;
sbit	SPIIF		=0xc6:2;
sbit	T0IF	    =0xC6:3;
sbit	OPAIF    	=0xC6:4;



sbit	FP17M = 0xC1:7;
sbit	FP16M = 0xC1:6;
sbit	FP15M = 0xC1:5;
sbit	FP14M = 0xC1:4;
sbit	FP13M = 0xC1:3;
sbit	FP12M = 0xC1:2;
sbit	FP11M = 0xC1:1;
sbit	FP10M = 0xC1:0;

sbit	FP25M = 0xC2:5;
sbit	FP24M = 0xC2:4;
sbit	FP23M = 0xC2:3;
sbit	FP22M = 0xC2:2;
sbit	FP21M = 0xC2:1;
sbit	FP20M = 0xC2:0;

sbit	FP37M = 0xC3:7;
sbit	FP36M = 0xC3:6;
sbit	FP35M = 0xC3:5;
sbit	FP34M = 0xC3:4;
sbit	FP33M = 0xC3:3;
sbit	FP32M = 0xC3:2;
sbit	FP31M = 0xC3:1;
sbit	FP30M = 0xC3:0;

sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;

sbit	FP25 = 0xd2:5;
sbit	FP24 = 0xd2:4;
sbit	FP23 = 0xd2:3;
sbit	FP22 = 0xd2:2;
sbit	FP21 = 0xd2:1;
sbit	FP20 = 0xd2:0;

sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;



sbit	FP17UR = 0xE1:7;
sbit	FP16UR = 0xE1:6;
sbit	FP15UR = 0xE1:5;
sbit	FP14UR = 0xE1:4;
sbit	FP13UR = 0xE1:3;
sbit	FP12UR = 0xE1:2;
sbit	FP11UR = 0xE1:1;
sbit	FP10UR = 0xE1:0;

sbit	FP25UR = 0xE2:5;
sbit	FP24UR = 0xE2:4;
sbit	FP23UR = 0xE2:3;
sbit	FP22UR = 0xE2:2;
sbit	FP21UR = 0xE2:1;
sbit	FP20UR = 0xE2:0;

sbit	FP37UR = 0xE3:7;
sbit	FP36UR = 0xE3:6;
sbit	FP35UR = 0xE3:5;
sbit	FP34UR = 0xE3:4;
sbit	FP33UR = 0xE3:3;
sbit	FP32UR = 0xE3:2;
sbit	FP31UR = 0xE3:1;
sbit	FP30UR = 0xE3:0;








sbit	FGIE   = 0xDF:7;

sbit	FSTKPB2= 0xDF:2;
sbit	FSTKPB1= 0xDF:1;
sbit	FSTKPB0= 0xDF:0;
















#line 2 ".\Src\MAIN.c"


#line 1 ".\Include\E2PROM.H"




void E2promInit(void);
void e2prom_write(unsigned int e2_adders,unsigned int e2_data);
unsigned int e2prom_read(unsigned int e2_adders);

#line 13 ".\Include\E2PROM.H"

#line 5 ".\Src\MAIN.c"
#line 1 ".\Include\adc.h"




void delayad(unsigned int i);
void AdcInit();
unsigned long GetAdc();

typedef struct{

 unsigned int  time1;
 unsigned int  time2;
 unsigned int  time3;
 unsigned int  time4;
 unsigned int  time5;
 unsigned int  time6;

	WORD  time7;


	unsigned int flash_time1,flash_time2;

} TIME;




#line 6 ".\Src\MAIN.c"
#line 1 ".\Include\pin.h"




#line 13 ".\Include\pin.h"

















unsigned int ir_data=0;
unsigned int ir_time=0;

unsigned int shan_mode=0;
unsigned int ledmode=0;

TIME  TIM;

unsigned int cishu=0;
unsigned int pwm_out=106;
unsigned int bright;
unsigned int bright_last;
unsigned int hr=0;

unsigned int stop=0;

WORD  ad_sum;
WORD  ad_num;
WORD  ad_min=0xfff;
WORD  ad_max=0;
 unsigned int  ad_count=0;
TIME  AD_TEMP;


bit t0_need;
bit bit_1ms;

bit z_diya;
bit z_ad;
bit z_write;

unsigned int map=0;
sbit ir_ok_flag =map:3;
sbit z_ir       =map:4;

sbit z_cd=map:0;

unsigned int flag=0;
sbit on_off    =flag:0;
sbit z_limit   =flag:1;

sbit z_yes	    =flag:2;
sbit qufan      =flag:3;
sbit z_jianbian=flag:4;

sbit z_liang   =flag:5;
sbit z_an      =flag:6;
sbit z_auto    =flag:7;




unsigned int ir_get();
void ir_battle();
void choosemode();
void light_control();
void DATA_AD();

void PWM01_ON();
void PWM01_OFF();

void T0Init(void);
void Tm1Init(void);
void insleep();

void led_grady();


#line 7 ".\Src\MAIN.c"


#line 16 ".\Src\MAIN.c"
void __interrupt[0x08] interrupt_isr(void)
{
	if(T0IF)
	{
		T0C=162;
		T0IF=0;
		t0_need=1;
		ir_time++;




		if(z_limit)
		{
			TIM.flash_time1++;
			if(TIM.flash_time1>12)
			{
				if(TIM.flash_time2<200)
				{
					TIM.flash_time2++;
				}
				TIM.flash_time1=0;
			}
		}
		else
		{
			TIM.flash_time1=0;TIM.flash_time2=0;
 FP22 =0;cishu=0;
			qufan=0;
		}


		if(hr&&on_off)
		{
			TIM.time1++;
			if(TIM.time1>149)
			{
				TIM.time1=0;
				TIM.time2++;
			}
			if(TIM.time2>99)
			{
				TIM.time2=0;
				TIM.time3++;

			}
			if(TIM.time3>59)
			{
				TIM.time3=0;
				hr--;
				if(hr==0)
				{
					on_off=0;z_auto=0;
				}
			}
		}
		else
		{
			TIM.time1=0;TIM.time2=0;TIM.time3=0;
		}


			TIM.time4++;
			if(TIM.time4>24)
			{
				TIM.time4=0;
				TIM.time5++;
			}
			if(TIM.time5>49)
			{
				TIM.time5=0;


			}


	}

		if(TM1IF)
		{
			TM1IF=0;
			bit_1ms=1;
			TIM.time7++;
			stop++;

		}

}

#line 112 ".\Src\MAIN.c"
void main(void)
{
static unsigned int xx=0,yy=0;
bit shangdian;
	P1M=0XFF;
	P3M=0Xed;

	P2M=0XFF;

	E2promInit();
	FGIE=1;
	T0Init();
	Tm1Init();
	TM0CL=106;
	TM0CH=0xff;
	TM0D1H=0xff;

	if(e2prom_read(0x01)==0x55)
	{
		bright=e2prom_read(0x02);
	}
	else
	{
		bright=255;

		e2prom_write(0x01,0x55);
		e2prom_write(0x02,bright);
	}


	on_off=1;
	z_an=0;z_liang=0;


	shangdian=1;
	while(shangdian)
	{
		WDTR=0X5au;
		if(TIM.time5>=3)
		{
			shangdian=0;
		}
		light_control();
		delayad(100);
	}



bright_last=bright;
pwm_out=106;

	z_limit=0;
	ledmode=4;

	z_cd=0;
	z_yes=0;
	z_diya=0;
	z_ad=0;

	while(1)
	{
		WDTR=0X5au;


		if(t0_need)
		{
			t0_need=0;
			if(z_yes==0)
			{light_control();}
			else
			{
					if(FP34 ==0)
					{
						xx++;
						if(xx>99)
						{
							xx=0;
							z_yes=0;
						}
					}
			}
				if(z_diya==0)
				{
				ir_data=ir_get();
				}
				ir_battle();
			ir_time=0;z_ir=0;

		}

		if(bit_1ms)
		{
			bit_1ms=0;
			if(z_jianbian==0)
			{
			DATA_AD();
			}

		}
		choosemode();

		if(z_write)
			{
				z_write=0;

				e2prom_write(0x02,bright);

			}


	}


}

#line 234 ".\Src\MAIN.c"
void DATA_AD()
{
	ad_num=GetAdc();
	ad_count++;
	ad_sum+=ad_num;
	if(ad_num>ad_max)
	{
		ad_max=ad_num;
	}
	if(ad_num<ad_min)
	{
		ad_min=ad_num;
	}

	if(ad_count>9)
	{
		ad_count=0;
		ad_sum=ad_sum-ad_min-ad_max;
		ad_sum/=8;

		if(ad_sum>=1792)
		{
			AD_TEMP.time1++;
			AD_TEMP.time2=0;
			AD_TEMP.time3=0;
			AD_TEMP.time4=0;
			AD_TEMP.time5=0;
			AD_TEMP.time6=0;
			if(AD_TEMP.time1>3)
			{
				AD_TEMP.time1=0;
				ledmode=4;
			}

		}
		else if(ad_sum>=1690)
		{
			AD_TEMP.time1=0;
			AD_TEMP.time2++;
			AD_TEMP.time3=0;
			AD_TEMP.time4=0;
			AD_TEMP.time5=0;
			AD_TEMP.time6=0;
			if(AD_TEMP.time2>3)
			{
				AD_TEMP.time2=0;
				ledmode=3;
			}
		}
		else if(ad_sum>=1587)
		{
			AD_TEMP.time1=0;
			AD_TEMP.time2=0;
			AD_TEMP.time3++;
			AD_TEMP.time4=0;
			AD_TEMP.time5=0;
			AD_TEMP.time6=0;
			if(AD_TEMP.time3>3)
			{
				AD_TEMP.time3=0;
				ledmode=2;
			}
		}
		else if(ad_sum>=1512)
		{
			AD_TEMP.time1=0;
			AD_TEMP.time2=0;
			AD_TEMP.time3=0;
			AD_TEMP.time4++;
			AD_TEMP.time5=0;
			AD_TEMP.time6=0;
			if(AD_TEMP.time4>3)
			{
				AD_TEMP.time4=0;
				ledmode=1;
			}
		}
		else if(ad_sum<=1280)
		{
			AD_TEMP.time1=0;
			AD_TEMP.time2=0;
			AD_TEMP.time3=0;
			AD_TEMP.time4=0;
			AD_TEMP.time5++;
			AD_TEMP.time6=0;
			if(AD_TEMP.time5>3)
			{
				AD_TEMP.time5=0;
				ledmode=0;z_diya=1;
				on_off=0;
				z_auto=0;z_yes=0;
				led_grady();
			}
		}
		else
		{
			AD_TEMP.time1=0;
			AD_TEMP.time2=0;
			AD_TEMP.time3=0;
			AD_TEMP.time4=0;
			AD_TEMP.time5=0;
			AD_TEMP.time6++;
			if(AD_TEMP.time6>3)
			{
				AD_TEMP.time6=0;
				ledmode=0;
			}
		}

		if(ad_sum>=1433)
		{
			z_diya=0;
		}
		ad_sum=0;
		ad_min=0xfff;
		ad_max=0;
	}
}

#line 360 ".\Src\MAIN.c"
void led_show()
{
	switch(ledmode)
	{
		case 0: FP14 =1;FP13 =1;FP12 =1;FP11 =1;   break;
		case 1: FP14 =1;FP13 =1;FP12 =1;FP11 =0;   break;
		case 2: FP14 =1;FP13 =1;FP12 =0;FP11 =0;   break;
		case 3: FP14 =1;FP13 =0;FP12 =0;FP11 =0;   break;
		case 4: FP14 =0;FP13 =0;FP12 =0;FP11 =0;   break;
	}

	if(z_cd)
	{
		if(TIM.time7>500)
		{
 FP15 =~ FP15;
			TIM.time7=0;
		}
		z_diya=0;
	}
	else
	{
 FP15 =1;TIM.time7=0;
	}
}

#line 393 ".\Src\MAIN.c"
void led_grady()
{
	if(on_off)
	{
		z_an=0;
		if(z_liang==0)
		{z_liang=1;z_jianbian=1;}
	}
	else
	{
		z_liang=0;
		if(z_an==0)
		{z_an=1;z_jianbian=1;}
	}
}

#line 416 ".\Src\MAIN.c"
void ir_battle()
{
	if(ir_ok_flag)
	{
		ir_ok_flag=0;
		z_limit=1;shan_mode=2;
		switch(ir_data)
		{
			case 0x43: on_off=1;
						z_auto=0;
						if(z_cd)
						{
							z_yes=1;
						}TIM.flash_time1=0;TIM.flash_time2=0;
						break;

			case 0x0a: on_off=1;
						z_auto=0;
						if(z_cd)
						{
							z_yes=1;
						}TIM.flash_time1=0;TIM.flash_time2=0;
						break;

			case 0x0d: on_off=0;hr=0;
						z_auto=0;z_yes=0;
						break;
			case 0x1f: on_off=0;hr=0;
						z_auto=0;z_yes=0;
						break;

			case 0x46: on_off=1;z_auto=1;hr=0;
						z_yes=0;TIM.flash_time1=0;TIM.flash_time2=0;


								break;
			case 0x01: on_off=1;z_auto=1;hr=0;
						z_yes=0;TIM.flash_time1=0;TIM.flash_time2=0;


								break;
		}
		if(on_off)
		{
			switch(ir_data)
			{
				case 0x07: if(bright<240)
							{
								bright+=15;
							}
							else
							{
								bright=255;
							}z_jianbian=1;
							break;
				case 0x08: bright=255;z_jianbian=1;break;
				case 0x09: if(bright>130)
							{
								bright-=15;
							}
							else
							{
								bright=120;


							}z_jianbian=1;
							break;

				case 0x5a: bright=181;z_jianbian=1;break;





				case 0x44: hr=3;break;
				case 0x15: hr=2;break;
				case 0x16: hr=4;break;

				case 0x05: hr=3;break;
				case 0x1b: hr=2;break;
				case 0x03: hr=4;break;
			}

		}
		if(bright!=bright_last)
		{
			z_write=1;
		}
		bright_last=bright;

		led_grady();

	}
}

#line 518 ".\Src\MAIN.c"
void light_control()
{
	static unsigned int y[4];
	if(z_auto)
	{
		if(FP34)
		{
			y[0]++;
			y[1]=0;
			if(y[0]>99)
			{
				y[0]=0;
				on_off=0;
				z_cd=1;hr=0;
			}
		}
		else
		{
			y[0]=0;
			y[1]++;
			if(y[1]>99)
			{
				y[1]=0;
				on_off=1;
				z_cd=0;
			}
		}
	}
	else
	{
		if(FP34)
		{
			y[2]++;
			y[3]=0;
			if(y[2]>99)
			{
			if(on_off==0)
			{z_auto=1;}
			else
			{on_off=0;z_auto=1;}
			y[2]=0;
			z_cd=1;
			}
		}
		else
		{
			y[2]=0;
			y[3]++;
			if(y[3]>99)
			{
			if(on_off)
			{z_auto=1;}
			y[3]=0;
			z_cd=0;
			}
		}
	}

	led_grady();
}

#line 586 ".\Src\MAIN.c"
void CHANGE()
{
	if(pwm_out<bright){pwm_out++;}
	else if(pwm_out>bright){pwm_out--;}
	else{pwm_out=bright;z_jianbian=0;}
}
void CHANGE_DOWN()
{
	if(pwm_out>106){pwm_out--;}
	else{pwm_out=106;z_jianbian=0;}
}

#line 605 ".\Src\MAIN.c"
void choosemode()
{


	if(z_limit)
	{

		if(qufan)
		{
 FP14 =0;FP13 =0;FP12 =0;FP11 =0;FP15 =0;
		}
		else
		{
 FP14 =1;FP13 =1;FP12 =1;FP11 =1;FP15 =1;
		}
		if(TIM.flash_time2>6)
		{qufan=~qufan;cishu++;TIM.flash_time2=0;}

		if(cishu>=shan_mode)
		{z_limit=0;cishu=0;}




	}
	else
	{


		if(on_off)
		{
			led_show();

		}
		else
		{
			z_limit=0;cishu=0;
			if(FP34)
			{
				led_show();
			}
			else
			{
 FP14 =1;FP13 =1;FP12 =1;FP11 =1;FP15 =1;
			}
		}


	}
led_grady();

		if(on_off)
		{
				if(z_jianbian)
				{

					if(stop<5)
					{return;}
					stop=0;

					CHANGE();PWM01_ON();

				}
				else
				{
					PWM01_ON();

				}

		}
		else
		{
			if(z_jianbian)
			{
				if(stop<5)
				{return;}
				stop=0;

				CHANGE_DOWN();PWM01_ON();

			}
			else
			{
				PWM01_OFF();FP22 =0;
				if(z_limit==0)
				{
					insleep();
				}
			}
		}



}

#line 707 ".\Src\MAIN.c"
void insleep()
{
	if(ir_time||ir_ok_flag||z_ir||z_auto|| FP34 ||z_diya)
	{return;}

 FP14 =1;FP13 =1;FP12 =1;FP11 =1;FP15 =1;

TIM.time4=0;TIM.time5=0;z_ad=0;
cishu=0;qufan=0;TIM.flash_time2=0;

	T0M=0;
	T0IF=0;
	T0IE=0;
	FGIE=0;

	PWM01_OFF();


	ADM=0x00;
	P3W=0X12;
	__asm{nop}
	__asm{nop}
	__asm{nop}
	FRPIE=1;
	FRPIF=0;

 __asm{SleepMode};

	FRPIE=0;
	FRPIF=0;

	P3W=0X00;
	WDTR=0x5a;


	if(FP31 ==0)
	{
		z_ir=1;
	}
	FGIE=1;
	T0Init();
	Tm1Init();

}

#line 759 ".\Src\MAIN.c"
void PWM01_ON()
{
	TM0M=0xe2;
	PWM0E=0x25;

	TM0D1L=pwm_out;
}
void PWM01_OFF()
{
	TM0M=0x00;
	PWM0E=0x00;
}


#line 779 ".\Src\MAIN.c"
void T0Init(void)
{
	T0M=0X90;
	T0C=162;
	T0IF=0;
	T0IE=1;

}


#line 795 ".\Src\MAIN.c"

void Tm1Init(void)
{
	TM1M=0Xb2;
	TM1C=68;

	TM1IF=0;
	TM1IE=1;
}

