#line 1 ".\Src\ir.c"
#line 1 "C:\Sonix\SN8_C_~1.264\C\include\SonixDef.h"



unsigned long GetRollingCode(unsigned int offset);








struct _intrinsicbitfield
{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};













#line 1 ".\Src\ir.c"
#line 1 ".\Include\fc2704.h"

#line 5 ".\Include\fc2704.h"








struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;
















sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;
sfr	RBANK = 0x87;


 sfr    TM0M    =0X90;
 sfr    TM0CL   =0X91;
 sfr    TM0CH   =0X92;
 sfr    TM0D0L  =0X93;
 sfr    TM0D0H  =0X94;
 sfr    TM0D1L  =0X95;
 sfr    TM0D1H  =0X96;
 sfr    PWM0E   =0X97;

 sfr	SPIC0	=0X98;
 sfr	SPIC1	=0X99;
 sfr	SPIBUF	=0X9A;


 sfr    TM1M    =0XA0;
 sfr    TM1C    =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1   =0XA3;
 sfr    TM1D2   =0XA4;
 sfr    TM1D3   =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;


 sfr    TM2M    =0XB0;
 sfr    TM2C    =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1   =0XB3;
 sfr    TM2D2   =0XB4;
 sfr    TM2D3   =0XB5;
 sfr    PWM2E   =0XB6;





 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;




 sfr    ADM    =0XB9;
 sfr    ADB    =0XBa;
 sfr    ADR    =0XBb;
 sfr    ADT    =0XBc;
 sfr    VREFH  =0XBd;
 sfr    ADPCON =0Xbe;
 sfr	PEDGE  =0XBF;


 sfr    P1W    =0XC0;
 sfr	P1M    =0xC1;
 sfr	P2M    =0XC2;
 sfr	P3M    =0XC3;
 sfr    INTRQ1 =0XC6;
 sfr    INTEN1 =0XC7;

 sfr    INTRQ  =0XC8;
 sfr    INTEN  =0XC9;
 sfr	OSCM   =0xCA;
 sfr	RCADJ  =0XCB;
 sfr	WDTR   =0XCC;
 sfr    OPTION =0XCD;
 sfr	PCL    =0XCE;
 sfr	PCH    =0XCF;


 sfr	P1     =0XD1;
 sfr	P2     =0XD2;
 sfr	P3     =0XD3;
 sfr	T0M    =0XD8;
 sfr	T0C    =0XD9;
 sfr    OPA1CON=0XDA;
 sfr    OPA2CON=0XDB;
 sfr    P1OD   =0XDC;
 sfr    P2W    =0Xdd;
 sfr    P3W    =0XDE;
 sfr    STKP   =0XDF;


 sfr	P1UR=0XE1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;


 sfr	P1PD=0XEC;
 sfr	P2PD=0XED;
 sfr	P3PD=0XEE;


sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAB:2;
sbit	E2P_PG		=0xAB:1;
sbit	E2P_RD		=0xAB:0;

sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		=0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;


sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		=0xA8:4;
sbit	HBB		=0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		=0xA8:7;



sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;




sbit	CHS0		=0xB9:0;
sbit	CHS1		=0xB9:1;
sbit	CHS2		=0xB9:2;
sbit	CHS3		=0xB9:3;
sbit	GCHS		=0xB9:4;
sbit	EOC		=0xB9:5;
sbit	FADS		=0xB9:6;
sbit	ADENB		=0xB9:7;



sbit	ADCKS0		=0xBB:4;
sbit	ADCKS1		=0xBB:6;



sbit	ADT_0		=0xBc:0;
sbit	ADT_1		=0xBC:1;
sbit	ADT_2		=0xBC:2;
sbit	ADT_3		=0xBC:3;
sbit	ADT_4		=0xBC:4;

sbit	adts_0		=0xBC:6;
sbit	adts_1		=0xBC:7;


sbit	VHS0		=0xBD:0;
sbit	VHS1		=0xBD:1;

sbit	EVHENB		=0xBD:7;



sbit	PWM0OE		=0x90:0;
sbit	ALOAD0		=0x90:1;
sbit	T0CKS0		=0x90:2;
sbit	T0CKS1		=0x90:3;
sbit	T0PS0		=0x90:4;
sbit	T0PS1		=0x90:5;
sbit	T0PS2		=0x90:6;
sbit	T0TR		=0x90:7;

sbit	PWM1OE		=0xA0:0;
sbit	ALOAD1		=0xA0:1;
sbit	T1CKS0		=0xA0:2;
sbit	T1CKS1		=0xA0:3;
sbit	T1PS0		=0xA0:4;
sbit	T1PS1		=0xA0:5;
sbit	T1PS2		=0xA0:6;
sbit	T1TR		=0xA0:7;

sbit	PWM2OE		=0xB0:0;
sbit	ALOAD2		=0xB0:1;
sbit	T2CKS0		=0xB0:2;
sbit	T2CKS1		=0xB0:3;
sbit	T2PS0		=0xB0:4;
sbit	T2PS1		=0xB0:5;
sbit	T2PS2		=0xB0:6;
sbit	T2TR		=0xB0:7;


sbit	PWM01E		=0x97:0;
sbit	PWM00HL		=0x97:1;
sbit	PWM01HL		=0x97:2;
sbit	PWM0M		=0x97:3;
sbit	PWM00OE		=0x97:4;
sbit	PWM01OE		=0x97:5;
sbit	TC0WAKE		=0x97:6;
sbit	PWM0OD		=0x97:7;

sbit	PWM11E		=0xA6:0;
sbit	PWM10HL		=0xA6:1;
sbit	PWM11HL		=0xA6:2;
sbit	PWM1M		=0xA6:3;
sbit	PWM10OE		=0xA6:4;
sbit	PWM11OE		=0xA6:5;
sbit	TC1WAKE		=0xA6:6;
sbit	PWM1OD		=0xA6:7;

sbit	PWM21E		=0xB6:0;
sbit	PWM20HL		=0xB6:1;
sbit	PWM21HL		=0xB6:2;
sbit	PWM2M		=0xB6:3;
sbit	PWM20OE		=0xB6:4;
sbit	PWM21OE		=0xB6:5;
sbit	TC2WAKE		=0xB6:6;
sbit	PWM2OD		=0xB6:7;



sbit	INT0IE		=0xc9:0;
sbit	INT1IE		=0xc9:1;
sbit	TM0IE		=0xc9:2;
sbit	TM1IE		=0xc9:3;
sbit	TM2IE		=0xc9:4;
sbit	FRPIE		=0xc9:5;
sbit	I2CIE		=0xc9:6;
sbit	ADCIE		=0xc9:7;

sbit	E2PIE		=0xc7:0;
sbit	TKTMRIE		=0xc7:1;
sbit	SPIIE		=0xc7:2;
sbit	T0IE	    =0xC7:3;
sbit	OPAIE    	=0xC7:4;

sbit	INT0IF		=0xc8:0;
sbit	INT1IF		=0xc8:1;
sbit	TM0IF		=0xc8:2;
sbit	TM1IF		=0xc8:3;
sbit	TM2IF		=0xc8:4;
sbit	FRPIF		=0xc8:5;
sbit	I2CIF		=0xc8:6;
sbit	ADCIF		=0xc8:7;

sbit	E2PIF		=0xc6:0;
sbit	TKTMRIF		=0xc6:1;
sbit	SPIIF		=0xc6:2;
sbit	T0IF	    =0xC6:3;
sbit	OPAIF    	=0xC6:4;



sbit	FP17M = 0xC1:7;
sbit	FP16M = 0xC1:6;
sbit	FP15M = 0xC1:5;
sbit	FP14M = 0xC1:4;
sbit	FP13M = 0xC1:3;
sbit	FP12M = 0xC1:2;
sbit	FP11M = 0xC1:1;
sbit	FP10M = 0xC1:0;

sbit	FP25M = 0xC2:5;
sbit	FP24M = 0xC2:4;
sbit	FP23M = 0xC2:3;
sbit	FP22M = 0xC2:2;
sbit	FP21M = 0xC2:1;
sbit	FP20M = 0xC2:0;

sbit	FP37M = 0xC3:7;
sbit	FP36M = 0xC3:6;
sbit	FP35M = 0xC3:5;
sbit	FP34M = 0xC3:4;
sbit	FP33M = 0xC3:3;
sbit	FP32M = 0xC3:2;
sbit	FP31M = 0xC3:1;
sbit	FP30M = 0xC3:0;

sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;

sbit	FP25 = 0xd2:5;
sbit	FP24 = 0xd2:4;
sbit	FP23 = 0xd2:3;
sbit	FP22 = 0xd2:2;
sbit	FP21 = 0xd2:1;
sbit	FP20 = 0xd2:0;

sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;



sbit	FP17UR = 0xE1:7;
sbit	FP16UR = 0xE1:6;
sbit	FP15UR = 0xE1:5;
sbit	FP14UR = 0xE1:4;
sbit	FP13UR = 0xE1:3;
sbit	FP12UR = 0xE1:2;
sbit	FP11UR = 0xE1:1;
sbit	FP10UR = 0xE1:0;

sbit	FP25UR = 0xE2:5;
sbit	FP24UR = 0xE2:4;
sbit	FP23UR = 0xE2:3;
sbit	FP22UR = 0xE2:2;
sbit	FP21UR = 0xE2:1;
sbit	FP20UR = 0xE2:0;

sbit	FP37UR = 0xE3:7;
sbit	FP36UR = 0xE3:6;
sbit	FP35UR = 0xE3:5;
sbit	FP34UR = 0xE3:4;
sbit	FP33UR = 0xE3:3;
sbit	FP32UR = 0xE3:2;
sbit	FP31UR = 0xE3:1;
sbit	FP30UR = 0xE3:0;








sbit	FGIE   = 0xDF:7;

sbit	FSTKPB2= 0xDF:2;
sbit	FSTKPB1= 0xDF:1;
sbit	FSTKPB0= 0xDF:0;
















#line 2 ".\Src\ir.c"







extern unsigned int map;
sbit ir_ok_flag =map:3;
sbit z_ir       =map:4;

#line 20 ".\Src\ir.c"

void delay_us(unsigned int i)
{
	while(i--)
	{
	}
}
unsigned int ir_get()
{
	unsigned int ir_count_1=0,ir_count_2=0,ir_count_3=0;

	unsigned int data_l=0,data_h=0,use_l=0,use_h=0,temp=0;
	sbit temp_one	 =temp:7;


	ir_ok_flag=0;
	if(FP31){return 0;}

	ir_count_1=200;
__9ms:
		delay_us(25);
		ir_count_1--;
		if(!ir_count_1){return 0;}
		if(! FP31){goto __9ms;}



		ir_count_1=100;
__45ms:
		delay_us(25);
		ir_count_1--;
		if(!ir_count_1){return 0;}
		if(FP31){goto __45ms;}



start:
		ir_count_1=0;
		ir_count_2=0;
__560us:
		delay_us(6);
		ir_count_1++;
		if(ir_count_1>200){return 0;}
		if(! FP31){goto __560us;}

__5600us:
		delay_us(6);
		ir_count_2++;
		if(ir_count_2>200){return 0;}
		if(FP31){goto __5600us;}


		ir_count_1<<=1;
		if(ir_count_1>ir_count_2){temp_one=0;}else{temp_one=1;}
		ir_count_3++;
		if(ir_count_3==8){use_l=temp;}
		else if(ir_count_3==16){use_h=temp;}
		else if(ir_count_3==24){data_l=temp;}
		else if(ir_count_3==32){data_h=temp;}
		temp>>=1;




		if (ir_count_3>31)
		{

			if((data_l^data_h)!=0xff)
			{
				return 0;
			}
			else
			{

				if(((use_l== 0x00)&&(use_h== 0xff))||	((use_l==0x80)&&(use_h==0x7f)))
				{}
				else
				{
					return 0;
				}
			}
		}
		else
		{
			goto start;
		}

		ir_ok_flag=1;
		return data_l;
}
